#pragma once

#include <QHash>
#include <QString>
#include <QVariant>

namespace osdev {
namespace components {
namespace datamodels {

class ModelDataItem
{
public:
    ModelDataItem();
    ModelDataItem(const QHash<QString, QVariant> &data_item);

    void        setData(const QString &name, const QVariant &value);
    QVariant    getData(const QString &name) const;
    int         items();
    QStringList getKeys() { return m_itemHash.keys(); }

    QString     asString();

private:
    QHash<QString, QVariant> m_itemHash;
};

}   // End namespace datamodels
}   // End namespace components
}   // End namespace osdev
